#ifndef _X6502STRUCTH

#include "fceu.h"

typedef struct __X6502 {
 // 0
  int32 tcount;     /* Temporary cycle counter */
 // 4
  uint16 PC;        /* I'll change this to uint32 later... */
                                /* I'll need to AND PC after increments to 0xFFFF */
                                /* when I do, though.  Perhaps an IPC() macro? */
 // 6,7,8,9,A,B
  uint8 A,X,Y,S,P,mooPI;
 // C
  uint8 jammed;

 // 10
  int32 count;
 // 14
  uint32 IRQlow;    /* Simulated IRQ pin held low(or is it high?).
                                   And other junk hooked on for speed reasons.*/
 // 15
  uint8 DB;         /* Data bus "cache" for reads from certain areas */
 // 18
  int preexec;      /* Pre-exec'ing for debug breakpoints. */

	#ifdef FCEUDEF_DEBUGGER
        void (*CPUHook)(struct __X6502 *);
        uint8 (*ReadHook)(struct __X6502 *, unsigned int);
        void (*WriteHook)(struct __X6502 *, unsigned int, uint8);
	#endif

} X6502;
#define _X6502STRUCTH
#endif
